<?php
 
/**
 * ASC - Wordy Password
 *
 * Copyright (C) 2018 Andrew Stevens Consulting
 *
 * @package    asconsulting/wordy_password
 * @link       https://andrewstevens.consulting
 */

 
namespace Asc;
 
class WordyPassword
{
 	
	static function generate($intLength = 10) {
		$arrWordyPassword = array("abed","abet","able","ably","abut","aced","acer","aces","ache","acid","acre","acts","adds","afar","agar","aged","ager","ages","agog","ague","aide","ails","aims","airs","airy","ajar","akin","alas","alga","ally","alma","alms","aloe","alps","also","alto","alum","amen","amid","amok","amps","amyl","ands","anew","anon","ante","anti","ants","aped","aper","apes","apex","apse","aqua","arch","arcs","area","ares","arid","arms","army","arts","asks","atom","atop","aunt","aura","auto","aver","avid","avow","away","awed","awls","awry","axed","axer","axes","axis","axle","axon","ayer","ayes","babe","baby","back","bade","bads","bail","bait","bake","bald","bale","balk","balm","band","bane","bang","bank","bans","barb","bard","bare","bark","barn","bars","base","bash","bask","bass","bath","bats","baud","bawl","bays","bead","beak","beam","bean","bear","beat","beau","beck","beds","beef","been","beep","bees","beet","begs","bell","belt","bely","bend","bent","best","beta","bets","bevy","bias","bibs","bide","bids","bier","bike","bile","bilk","bill","bind","bing","bins","bird","bite","bits","blab","bled","blew","blip","blob","bloc","blot","blow","blue","blur","boar","boat","bobs","bode","body","bogs","boil","bold","boll","bolt","bond","bone","bony","book","boom","boon","boor","boos","boot","bore","born","boss","both","bout","bowl","bows","boys","brae","brag","bran","brat","bray","bred","brew","brig","brim","brow","buck","buds","buff","bugs","bulb","bulk","bump","bums","bunk","buns","bunt","buoy","burl","burn","burr","bury","bush","buss","busy","buys","buzz","byes","byte","cabs","cafe","cage","cake","calf","call","calm","came","camp","cane","cans","cape","caps","card","care","cars","cart","case","cash","cask","cast","cats","cave","caws","cell","cent","chap","char","chat","chef","chew","chin","chip","chop","chum","cite","city","clad","clam","clan","clap","claw","clay","clip","clod","clog","club","clue","coal","coat","coax","code","cods","coil","coin","cold","colt","comb","come","cone","cons","cook","cool","coop","cope","cops","copy","cord","core","cork","corn","cost","cots","cove","cowl","cows","cozy","crab","crag","cram","crew","crib","crop","crow","cube","cubs","cued","cues","cuff","cull","cult","cups","curb","cure","curl","curs","curt","cusp","cuss","cute","cuts","cyst","czar","dads","dale","dame","damn","damp","dams","dare","dark","darn","dart","dash","data","date","dawn","days","daze","dead","deaf","deal","dean","dear","debt","deck","deed","deem","deep","deer","defy","dell","demo","dens","dent","deny","desk","dews","dewy","dial","dice","died","dies","diet","digs","dime","dims","dine","dint","dips","dire","dirt","disc","dish","disk","dive","dock","doer","does","dogs","dole","doll","dome","done","dons","doom","door","dope","dose","dote","doth","dots","dove","down","doze","drab","drag","draw","drew","drip","drop","drum","dual","dubs","duck","dude","duel","dues","duke","dull","duly","dumb","dump","dune","dusk","dust","duty","dyed","dyer","dyes","each","earl","earn","ears","ease","east","easy","eats","ebbs","echo","eddy","edge","edit","eels","eggs","egos","eked","ekes","elks","elms","else","emit","ends","envy","epic","eras","ergo","errs","espy","even","ever","eves","evil","ewer","ewes","exam","exit","eyed","eyer","eyes","face","fact","fade","fail","fain","fair","fake","fall","fame","fang","fans","fare","farm","fast","fate","fats","fawn","fear","feat","feds","feed","feel","fees","feet","fell","felt","fern","feud","fews","fife","figs","file","fill","film","find","fine","fins","fire","firm","fish","fist","fits","five","flab","flag","flap","flat","flaw","flax","flea","fled","flee","flew","flip","flit","flop","flow","foam","foci","foes","fogs","foil","fold","folk","fond","font","food","fool","foot","ford","fore","fork","form","fort","foul","four","fowl","fray","free","fret","frog","from","fuel","full","fume","fund","furs","fury","fuss","gain","gait","gale","gall","game","gaps","garb","gasp","gate","gave","gaze","gear","gels","gems","gene","germ","gets","gift","gigs","gild","gill","gilt","gins","gird","girl","girt","give","glad","glee","glen","glow","glue","gnat","gnaw","goad","goal","goat","gods","goer","goes","gold","golf","gone","gong","good","gore","gosh","goth","goto","gown","grab","gray","grew","grey","grid","grim","grin","grip","grit","grow","grub","gulf","gull","gulp","gums","guns","guru","gush","gust","guts","guys","gyms","hack","hail","hair","hale","half","hall","halt","hams","hand","hang","hard","hare","hark","harp","hart","hash","hate","hath","hats","haul","have","hawk","hays","haze","hazy","head","heal","heap","hear","heat","heed","heel","heir","held","helm","help","hems","hens","herb","herd","here","hero","hers","hews","hide","high","hike","hill","hilt","hims","hind","hint","hips","hire","hiss","hive","hoar","hoax","hogs","hold","home","hone","hood","hoof","hook","hoop","hoot","hope","hops","horn","hose","host","hour","howl","hows","hubs","hued","hues","huge","hugs","hull","hums","hurl","hush","husk","hymn","hype","iced","ices","icon","idea","idle","idly","idol","illy","imps","inch","inks","inns","into","ions","ires","iris","irks","iron","isle","itch","item","jabs","jack","jade","jams","jars","jaws","jazz","jean","jeep","jeer","jest","jets","jigs","jobs","jogs","john","join","joke","jolt","jots","joys","jump","jury","just","keel","keen","keep","kept","keys","kick","kids","kill","kind","king","kiss","kite","kits","knee","knew","knit","knob","knot","know","labs","lace","lack","lads","lady","lags","laid","lain","lair","lake","lamb","lame","lamp","land","lane","laps","lard","lark","lash","lass","last","late","lath","lava","lawn","laws","lays","lazy","lead","leaf","leak","lean","leap","leer","left","legs","lend","lens","lent","less","lest","lets","levy","lids","lied","lien","lies","lieu","life","lift","like","lily","limb","lime","limp","line","link","lint","lion","lips","lisp","list","live","loaf","loan","lobe","lock","loft","logs","lone","long","look","loom","loon","loop","loot","lore","lose","loss","lost","lots","loud","lows","luck","lull","lump","lure","lurk","lute","lynx","lyre","mace","made","maid","mail","main","make","mall","malt","mane","mans","many","maps","mare","mark","mars","mart","mash","mask","mass","mast","mate","math","mats","mays","maze","mead","meal","mean","meat","meek","meet","meld","melt","memo","mend","menu","mere","mesh","mess","meta","mets","mews","mica","mice","miff","mild","mile","milk","mill","mind","mine","ming","mink","mint","mire","miss","mist","mite","moat","mobs","mock","mode","mold","mole","monk","mono","mood","moon","moor","moot","mops","more","morn","moss","most","moth","move","mows","much","muck","muds","mugs","mule","muse","musk","must","mute","myth","nags","nail","name","naps","navy","near","neat","neck","need","nest","nets","news","newt","next","nice","nick","nigh","nine","node","nods","none","nook","noon","nope","norm","nose","note","noun","nows","null","numb","nuts","oaks","oars","oath","oats","obey","odds","oder","odes","offs","oils","oily","okay","omit","once","ones","only","onto","oops","ooze","opal","open","opts","ores","orly","ours","outs","oval","oven","over","owed","owes","owls","owns","oxen","pace","pack","pact","page","paid","pail","pair","pale","pall","palm","pals","pane","pang","pans","pant","papa","pare","park","pars","part","pass","past","path","pats","pave","pawn","paws","pays","peak","peal","pear","peas","peat","peck","peek","peel","peep","peer","pegs","pelt","pend","pens","pent","pest","pets","pews","pick","pied","pier","pies","pigs","pike","pile","pine","ping","pink","pins","pint","pith","pits","pity","plan","play","plea","plod","plot","ploy","plug","plum","plus","pods","poem","poet","poll","polo","pond","pony","poof","pool","poor","pore","port","pose","post","pour","pout","prop","pros","prow","pubs","pull","pulp","pump","puns","punt","puny","pups","pure","push","puts","quit","quiz","race","rack","raft","rage","rags","raid","rail","rain","rake","ramp","rams","rang","rank","rant","raps","rapt","rare","rash","rasp","rate","rats","rave","raws","rays","read","real","ream","reap","rear","reds","reed","reef","reel","rein","rely","rend","reno","rent","rest","ribs","rice","rich","ride","rids","rift","rigs","rill","rime","rind","ring","riot","ripe","rips","rise","risk","rite","rive","road","roam","roar","robe","robs","rock","rode","rods","roes","role","roll","romp","roof","rook","room","root","rope","rose","rosy","rots","rout","rove","rows","rubs","ruby","rude","rues","rugs","ruin","rule","rump","rung","runs","rush","rust","ruts","sack","safe","sage","sags","said","sail","sake","sale","salt","same","sand","sane","sang","sank","saps","sash","sate","save","saws","says","scam","scan","scar","scow","scum","seal","seam","sear","seas","seat","sect","seed","seek","seem","seen","seep","seer","sees","self","sell","send","sent","serf","sets","sews","sham","shed","shin","ship","shod","shoe","shop","shot","show","shun","shut","sick","side","sift","sigh","sign","silk","sill","silt","sine","sing","sink","sips","sire","sirs","site","sits","size","skew","skim","skip","skis","slab","slam","slap","slat","slay","sled","slew","slid","slim","slip","slop","slot","slow","slug","slum","smog","smug","snap","snow","snug","soak","soap","soar","sobs","sock","soda","sofa","soft","soil","sold","sole","solo","some","song","sons","soon","soot","sore","sort","soul","soup","sour","span","spat","sped","spin","spit","spot","spun","spur","stab","stag","star","stay","stem","step","stew","stir","stop","stow","stub","stun","subs","such","suds","suit","sulk","sums","sung","sunk","suns","sure","surf","swam","swap","sway","swim","swum","tabs","tack","tact","tags","tail","take","tale","talk","tall","tame","tank","tans","tape","taps","tars","task","taut","taxi","team","tear","teas","teem","teen","tell","tend","tens","tent","term","test","text","than","that","thaw","them","then","they","thin","this","thud","thug","thus","tick","tide","tidy","tied","tier","ties","tile","till","tilt","time","tins","tint","tiny","tips","tire","toad","toed","toes","toil","told","toll","tomb","toms","tone","tons","took","tool","tops","tore","torn","toss","tour","town","tows","toys","trap","tray","tree","trek","trim","trip","trod","trot","true","tube","tubs","tuck","tuft","tugs","tune","turf","turn","twas","twig","twin","twos","type","ugly","undo","unit","unto","upon","urge","urns","used","user","uses","vale","vane","vans","vary","vase","vast","vats","veal","veer","veil","vein","vend","vent","verb","very","vest","veto","vial","vice","vied","vier","vies","view","vile","vine","visa","vita","void","volt","vote","vows","wade","waft","wage","wags","wail","wait","wake","walk","wall","wand","wane","want","ward","ware","warm","warn","warp","wars","wart","wary","wash","wasp","wave","waxy","ways","weak","wean","wear","webs","weds","weed","week","weep","weld","well","went","wept","were","west","wets","what","when","whew","whey","whim","whip","whit","whiz","whom","wick","wide","wife","wigs","wild","wile","will","wilt","wily","wind","wine","wing","wink","wins","wipe","wire","wiry","wise","wish","wisp","with","wits","woke","wolf","womb","wont","wood","woof","wool","woos","word","wore","work","worm","worn","wove","wrap","wren","writ","yank","yard","yarn","yawn","yeah","year","yell","yelp","yoke","your","yuck","zaps","zeal","zero","zest","zinc","zone","zoom","zoos");
		
		$arrCharacters = array('a','b','c','d','e','f','g','h','i','j','k','l','m','n','o','p','q','r','s','t','u','v','w','x','y','z','A','B','C','D','E','F','G','H','I','J','K','L','M','N','O','P','Q','R','S','T','U','V','W','X','Y','Z','0','1','2','3','4','5','6','7','8','9');
		
		$strPassword = '';
		
		if ($intLength < 4) {
			$strPassword = array_rand($arrCharacters, $intLength);
		} else {
			$intWords = floor($intLength/4);
			$intRandom = ($intLength - ($intWords * 4));
			if ($intRandom == 0) {
				$intWords--;
				$intRandom = 4;
			}
			$arrPasswordWords = array_rand($arrWordyPassword, $intWords);
			$intLoop = 0;
			$midToggle = false;
			foreach ($arrPasswordWords as $index) {
				$intLoop++;
				$strPassword .= ucwords($arrWordyPassword[$index]);
				if (!$midToggle && $intLoop >= (count($arrPasswordWords)/2)) {
					$midToggle = true;
					for ($x = 1; $x <= $intRandom; $x++) {
						$strPassword .= mt_rand(0,9);
					}
				}
			}
			return $strPassword;
		}
		
		
	}
	
} 
